import waba.ui.*;
import waba.fx.*;
import waba.sys.*;
import mWaba.*;
import mWaba.gui.*;
import mWaba.gui.control.*;
import mWaba.gui.graphics.*;

//##################################################################
public class mWabaDemo extends mApp{
//##################################################################
public static Button closeButton,monoButton,testButton,bigButton,smallButton;
Control p;
testForm tf;
boolean monoMode = false;
static mImage Asha, Krystal, MikeBig, MikeSmall, MikeTiny, Info, SmallInfo;
static ScrollablePanel tabHolder;
static testForm mainForm;

//==================================================================
protected mImage getImage(String image,String mask)
//==================================================================
{
	if (mask == null) return new mImage(image);
	else return new mImage(image,mask);
}
//==================================================================
public mWabaDemo()
//==================================================================
{
}
//==================================================================
protected void startup()
//==================================================================
{
	Asha = getImage("Ash.bmp",null);
	Krystal = getImage("Krystal.bmp",null);
	MikeBig = getImage("Mike-big-bw.bmp",null);
	MikeSmall = getImage("Mike-small-bw.bmp",null);
	MikeTiny = getImage("Mike-tiny-bw.bmp",null);
	Info = getImage("Info.bmp","InfoMask.bmp");
	SmallInfo = getImage("SmallInfo.bmp","SmallInfoMask.bmp");
	//==================================================================
	mControl.doubleBuffer = false;
	tf = mainForm = new testForm();
	if (!platform.equals("Java")) {
		tf.smallFont = true;
		mApp.appFrame.myFont = mApp.findFont("small",true);
	}
	tf.exec(null,null,Gui.FILL_FRAME);
}
//##################################################################
}
//##################################################################


//##################################################################
class testForm extends AppForm implements TimerProc{
//##################################################################

MenuBar menuBar;
boolean smallFont = false;
mButton dialog,config,info;
mChoice whichCard;
CardPanel cards;
mChoice imageChoice;
ScrollableHolder imageDisplay;
mInput lastName, firstName, age,fontMetrics;
mCheckBox male, female;
mControl personalInfo;
mButton [] people;
MenuItem [] configs,controls,screens,apps,board;
MenuItem about,quit;
Menu control, screen, app;
mComboBox smokes;

//==================================================================
public FormFrame getFormFrame()
//==================================================================
{
	FormFrame ff = super.getFormFrame();
	ff.rightButtons.addNext(info = new mButton(mWabaDemo.SmallInfo));
	return ff;
}
//==================================================================
public mInput popup(String what)
//==================================================================
{
	mInput ret = new mInput(what);
	mInputForm.attach(ret);
	return ret;
}
//==================================================================
public testForm()
//==================================================================
{
	title = "mWaba AWT - "+mWabaDemo.platform;
	resizable = true;
	titleCancel = new mButton("X"); 
	borderWidth = 2;
//------------------------------------------------------------------
	MultiPanel multi = new mTabbedPanel();
	ScrollablePanel sp;
	ScrollableHolder sh = new ScrollableHolder((mControl)multi);
	sh.modify(0,TakeControlEvents);
	addLast(sp = new ScrollablePanel(sh));
	sp.hbar.modify(SmallControl,0); sp.vbar.modify(SmallControl,0);
	mWabaDemo.tabHolder = sp;
	sp.modify(0,TakeControlEvents);
	sh.shrinkComponent = sh.stretchComponent = sp.shrinkComponent = sp.stretchComponent = true;
	mInputStack is;
	mPanel panel;
	Menu subMenu;
	MenuBar mb = menuBar = new MenuBar();
	mb.modify(AlwaysEnabled,0);
	PullDownMenu menu ;
//..................................................................
	menu = mb.addMenu("Config");
	configs = menu.menu.addItems(mString.split("Controls|Screen Size|Application|All"));
	control = subMenu = new Menu();
	controls = subMenu.addItems(mString.split("3-D|Flat|-|Gray|B/W|-|Enabled|Disabled|-|Editable|Not Editable|-|Buffered|Not Buffered"));
	configs[0].subMenu = subMenu;
	screen = subMenu = new Menu();
	screens = subMenu.addItems(mString.split("WinCE|Palm"));
	configs[1].subMenu = subMenu;
	app = subMenu = new Menu();
	apps = subMenu.addItems(mString.split("Scroll|Stretch/Shrink|-|Big Font|Small Font"));
	configs[2].subMenu = subMenu;
//..................................................................
	menu = mb.addMenu("File"); 
	MenuItem [] files = menu.menu.addItems(mString.split("New|Open|-|Save|Save as|-|Close|Exit"));
	quit = files[7];
	subMenu = new Menu();
 	MenuItem [] as = subMenu.addItems(mString.split("Text|HTML|Rich Text Format|Word"));
	files[4].subMenu = subMenu;
	subMenu = new Menu();
	subMenu.addItems(mString.split("Word 6.0|Word 95|Word 98|Word 2000"));
	as[3].subMenu = subMenu;
	menu = mb.addMenu("Help");
	about = menu.menu.addItems(mString.split("About"))[0];
	topControls = new mPanel();
	topControls.addLast(mb);
	mb.modifyAll(KeepImage,0,true);
	setupMenus();
//..................................................................
	multi.addItem(new SplitterTest(),"Splitter","Splitter Testing");
//..................................................................
 	multi.addItem(personalInfo = is = new mInputStack(),"Personal Info","Personal Information"); is.recessed = true;
//..................................................................
	lastName = is.addInput("Last Name:","Brereton");
	firstName = is.addInput("First Names:","Michael");
//..................................................................
	CheckBoxGroup gender = new CheckBoxGroup(); 
	mInputStack is2 = is.addInputStack("Gender:",2);
	male = is2.addCheckBox("Male",gender,true);
	female = is2.addCheckBox("Female",gender,false);
	age = is.addInput("Age:","30");
	ButtonBar bb = new ButtonBar();
	people = bb.add(mString.split("Mike|Ash|Krystal"));
//..................................................................
	//mChoice smokes = is.addChoice("Smokes:",mString.split("Never|Occasionally|Frequently|Like a chimney|Cuban Only|Menthols Only|To Look Cool"),0);
	smokes = is.addComboBox("Smokes:",mString.split("<Add>|Never|Occasionally|Frequently|Like a chimney|Cuban Only|Menthols Only|To Look Cool"),1);
	//smokes.modify(PaintDataOnly,0);
	is.add(bb,null);
//..................................................................
 	multi.addItem(is = new mInputStack(),"Contact Info","Contact Information"); is.recessed = true;
	is.doPopupInput = is.doubleLined = true; is.inputLength = 30;
//..................................................................	
	is.addInput("e-Mail:","michael_brereton@hotmail.com");
	is.addInput("Home Phone:","868-555-8248");
	is.addInput("Work Phone:","868-555-8248");
//..................................................................
 	multi.addItem(is = new mInputStack(),"User Info","User Information"); is.recessed = true;
//..................................................................	
	mInput mi;
	is.add(new mInput("smart-guy"),"User:");
	is.add(mi = new mInput("notmyreal"),"Password:"); mi.isPassword = true;
	is.add(new mLabel("Priviledges:"),null);
	mCheckBox cb;
	panel = new mPanel(); panel.recessed = true; panel.hGap = panel.vGap = 2;
	panel.addLast(cb = new mCheckBox("User")).setControl(Left|VCenter); cb.state = true;
	panel.addLast(cb = new mCheckBox("Administrator")).setControl(Left|VCenter); cb.state = true;
	panel.addLast(cb = new mCheckBox("Super-user")).setControl(Left|VCenter); cb.state = false;
	is.add(panel,null);
//..................................................................
 	multi.addItem(new ListTest(),"List","List Testing");
//..................................................................
	panel = new mPanel(); 
	mTextArea ta = new mTextArea(5,20);
	
	panel.addLast(ta.getScrollablePanel());//.setControl(Top|Left);
	panel.addLast(new mLabel("Enter text in the box above.")).setCell(HStretch);
	ta.text = "This is a multi-line text display.\nIt automatically handles scrolling.\nTry resizing the frame and see.\nIt will also handle selections using pen drags.\nTry it out!";
	//"\"My butter, garcon, is writ large in!\"\nA diner was heard to be chargin',\n\"I had to write there\",\nExclaimed waiter Pierre,\n\"I couldn't find room in the margerine.\"\nE. Howe, H. Lenstra, D. Moulton"; 

	multi.addItem(panel,"Text Area","Text Area");
//..................................................................
	multi.addItem(is = new mInputStack(),"Images","Images Panel"); is.recessed = true; //is.columns = 2;
//..................................................................
	panel = new mPanel(); panel.hGap = panel.vGap = 2;
	ImageControl ic;
	panel.addNext(new mLabel("Image:"));
	panel.addLast(new mLabel("Image Size:"));
	ScrollablePanel c = new ScrollablePanel(imageDisplay = new ScrollableHolder(ic = new ImageControl(mWabaDemo.MikeBig)));
	ic.borderWidth = 3;
	c.modify(SmallControl|DrawFlat,0);
	panel.addNext(c);
	c.fixSizeAt(120,120);
	panel.addLast(imageChoice = new mChoice("Me-Big|Me-Small|Me-Tiny|Wife|Daughter",0)).setControl(Left|Top);
	imageChoice.alwaysDrop = true;
	is.add(panel,null);
//..................................................................
	multi.addItem(new FontTest(),"Font/Frame Test","Font and Frame Testing"); 
}
//------------------------------------------------------------------
void setupMenus()
//------------------------------------------------------------------
{
	int ch = MenuItem.Checked;
	control.changeModifiers(0,MenuItem.Checked);
	screen.changeModifiers(0,MenuItem.Checked);
	app.changeModifiers(0,MenuItem.Checked);
	if (mControl.globalDrawFlat) controls[1].modifiers |= ch;
	else controls[0].modifiers |= ch;
	if (mColor.getMonochrome()) controls[4].modifiers |= ch;
	else controls[3].modifiers |= ch;
	if (mControl.globalEnabled) controls[6].modifiers |= ch;
	else controls[7].modifiers |= ch;
	if (mControl.globalEditable) controls[9].modifiers |= ch;
	else controls[10].modifiers |= ch;
	if (mControl.doubleBuffer) controls[12].modifiers |= ch;
	else controls[13].modifiers |= ch;
	if (mWabaDemo.tabHolder.shrinkComponent) apps[1].modifiers |= ch;
	else apps[0].modifiers |= ch;
	if (smallFont) apps[4].modifiers |= ch;
	else apps[3].modifiers |= ch;
}
//------------------------------------------------------------------
void changePerson(String first, String age, boolean isMale)
//------------------------------------------------------------------
{
	lastName.text = "Brereton";
	firstName.text = first;
	this.age.text = age;
	if (isMale) male.setState(true);
	else female.setState(true);
	personalInfo.repaintDataNow();
}
//==================================================================
public void onControlEvent(ControlEvent ev)
//==================================================================
{
	//..................................................................
	if (ev.type == ControlEvent.PRESSED){
	//..................................................................
		if (ev.target == smokes) {
			if (smokes.choice.selectedIndex == 0){
				if (smokes.choice.indexOf(smokes.oldText) == -1)
					smokes.choice.addItem(smokes.oldText);
				smokes.input.setText(smokes.oldText);
			}
		}if (ev.target == imageChoice){
			if (imageChoice.selectedIndex == 0) 
				imageDisplay.changeContents(new ImageControl(mWabaDemo.MikeBig));
			else if (imageChoice.selectedIndex == 1)
				imageDisplay.changeContents(new ImageControl(mWabaDemo.MikeSmall));
			else if (imageChoice.selectedIndex == 2)
				imageDisplay.changeContents(new ImageControl(mWabaDemo.MikeTiny));
			else if (imageChoice.selectedIndex == 3)
				imageDisplay.changeContents(new ImageControl(mWabaDemo.Asha));
			else if (imageChoice.selectedIndex == 4)
				imageDisplay.changeContents(new ImageControl(mWabaDemo.Krystal));
			imageDisplay.repaintNow();
		}else if (ev.target == people[0])
			changePerson("Michael","30",true);
		else if (ev.target == people[1])
			changePerson("Ashar","<Classified>",false);
		else if (ev.target == people[2])
			changePerson("Krystal","2",false);
		else if (ev.target == config){
			doConfigDisplay();
		}else if (ev.target == info){
			doAbout();
		}else
			super.onControlEvent(ev);
	//..................................................................
	}else if (ev instanceof MenuEvent && (ev.target == menuBar)){
		MenuEvent me = (MenuEvent)ev;
		onMenuEvent(me.selectedItem);
	}else if (ev instanceof FormEvent){
		onFormEvent((FormEvent)ev);
	}else
	//..................................................................
		super.onControlEvent(ev);
}
//==================================================================
public void onFormEvent(FormEvent ev)
//==================================================================
{
	if (ev.type == FormEvent.CLOSED && ev.target == quitBox){
		if (quitBox.exitValue == IDYES) close(0);
	}
}

//==================================================================
protected boolean canExit(int exitCode)
//==================================================================
{
	MessageBox qb = quitBox = new MessageBox("Exit Demo","Are you sure\nyou want to exit?",MBYESNO);
	qb.icon = mWabaDemo.Info;
	qb.exec(null,this);
	return false;
}
MessageBox quitBox;

//==================================================================
public void onMenuEvent(Object item)
//==================================================================
{
	Rect d = mWabaDemo.appFrame.getDim();
	boolean changedDisplay = true;
	if (item == controls[0]) mControl.globalDrawFlat = false;
	else if (item == controls[1]) mControl.globalDrawFlat = true;
	else if (item == controls[3]) mColor.setMonochrome(false);
	else if (item == controls[4]) mColor.setMonochrome(true);
	else if (item == controls[6]) mControl.globalEnabled = true;
	else if (item == controls[7]) mControl.globalEnabled = false;
	else if (item == controls[9]) mControl.globalEditable = true;
	else if (item == controls[10]) mControl.globalEditable = false;
	else if (item == screens[0]) {
		d.width = 240; d.height = 294;
	}else if (item == screens[1])
		d.width = d.height = 160;
	else if (item == apps[0])
		mWabaDemo.tabHolder.shrinkComponent = mWabaDemo.tabHolder.stretchComponent = false;
	else if (item == apps[1])
		mWabaDemo.tabHolder.shrinkComponent = mWabaDemo.tabHolder.stretchComponent = true;
	else if (item == apps[3]){
		smallFont = false;
		mApp.appFrame.myFont = mApp.findFont("gui",true);
	}else if (item == apps[4]) {
		smallFont = true;
		mApp.appFrame.myFont = mApp.findFont("small",true);
	}		
	else
		changedDisplay = false;
//..................................................................
	if (changedDisplay){ redisplayScreen(d.width,d.height);
//..................................................................
	}else if (item == controls[12]) {
		mControl.doubleBuffer = true;
		setupMenus();
	}else if (item == controls[13]) {
		mControl.doubleBuffer = false;
		setupMenus();
	}else if (item == configs[3]) doConfigDisplay();
	else if (item == about) {
		doAbout();
	}else if (item == quit){
		exit(0);
	}else {
		MessageBox mb = new MessageBox("Menu Event","There is no action\nfor that menu item.",0);
		mb.exec(null,null);
	}
}

public void doAbout()
{
	MessageBox mb = new MessageBox("About","mWaba AWT Demo\nWaba Beta 9\nMichael L Brereton\nNovember 1999\nmichael_brereton@hotmail.com",0);
	mb.icon = mWabaDemo.Info;
	mb.exec(null,null);
}
void doConfigDisplay()
{
	Form f = new DisplayOptions();
	mFrame fr = f.getFormFrame();
	fr.doSaveScreen = false;
	Gui.execFrame(fr,mApp.appFrame);
	Rect r = fr.getPreferredSize();
	fr.setRect(0,0,r.width,r.height);
	fr.repaintNow();
}

//==================================================================
void redisplayScreen(int w,int h)
//==================================================================
{
	mWabaDemo.tabHolder.reset();
	mWabaDemo.tabHolder.redisplay();
	mApp.appFrame.redisplay();
	mFrame f = mWabaDemo.mainForm.getFrame();
	f.modify(Invisible,0);
	f.eraseSavedScreen();
	Gui.refreshScreen();
	mWabaDemo.mainForm.getFrame().setRect(0,0,w,h);
	f.modify(0,Invisible);
	f.repaintNow();
	setupMenus();
}
//##################################################################
}
//##################################################################
//##################################################################
class DisplayOptions extends Form {
//##################################################################

mInput width,height;
mChoice mono,flat,stretch,font;
mButton palm,wince,custom;

//==================================================================
public DisplayOptions()
//==================================================================
{
	title = "Display Options";
	titleOK = new mButton("OK");

	mPanel mp = new mPanel();
	mp.addNext(palm = new mButton("Palm"));	
	mp.addNext(wince = new mButton("WinCE"));	
	mp.addLast(custom = new mButton("Custom"));	
	addLast(mp);

	mInputStack is = new mInputStack(); is.inputLength = 6;
	width = is.addInput("Width:","");
	height = is.addInput("Height:","");
	mono = is.addChoice("B/W:",mString.split("No|Yes"),0);
	flat = is.addChoice("Flat:",mString.split("No|Yes"),0);
	stretch = is.addChoice("Stretch:",mString.split("No|Yes"),0);
	font = is.addChoice("Font:",mString.split("Big|Small"),0);
	addLast(is);
	toControls();
}

//==================================================================
public void toControls(Object obj)
//==================================================================
{
	Rect r = mApp.appFrame.getRect();
	width.text = ""+r.width;
	height.text = ""+r.height;
	flat.selectedIndex = mono.selectedIndex = stretch.selectedIndex = font.selectedIndex = 0;
	if (mColor.getMonochrome()) mono.selectedIndex = 1;
	if (mControl.globalDrawFlat) flat.selectedIndex = 1;
	if (mWabaDemo.tabHolder.shrinkComponent) stretch.selectedIndex = 1;
	if (mWabaDemo.mainForm.smallFont) font.selectedIndex = 1;
}
//==================================================================
public void onControlEvent(ControlEvent ev)
//==================================================================
{
	if (ev.type == ev.PRESSED) {
		int w = 0, h = 0;
		boolean m = false, f = false, st = false, small = false, didChange = false;
		st = stretch.selectedIndex == 1;
		small = font.selectedIndex == 1;
		if (ev.target == palm) {
			w = h = 160;
			didChange = m = f = true;
		}else if (ev.target == wince){
			w = 240; h = 294;
			m = f = false;
			didChange = true;
		}else if (ev.target == custom){
			w = Convert.toInt(width.text); if (w < 100) w = 100;
			h = Convert.toInt(height.text); if (h < 100) h = 100;
			m = mono.selectedIndex == 1;
			f = flat.selectedIndex == 1;
			didChange = true;
		}
		if (didChange){
			if (small) mApp.appFrame.myFont = mApp.findFont("small",true);
			else mApp.appFrame.myFont = mApp.findFont("gui",true);
			mWabaDemo.mainForm.smallFont = small;
			mColor.setMonochrome(m);
			mControl.globalDrawFlat = f;
			mWabaDemo.tabHolder.reset();
			mWabaDemo.tabHolder.shrinkComponent = mWabaDemo.tabHolder.stretchComponent = st;
			mFrame mf = getFrame();
			mf.eraseSavedScreen();
			mf.modify(Invisible,0);
			mWabaDemo.mainForm.redisplayScreen(w,h);
			Rect r = getFrame().recalculateSize();
			getFrame().setRect(0,0,r.width,r.height);
			mf.modify(0,Invisible);
			getFrame().repaintNow();
			toControls();
		}
	}
}
//##################################################################
}
//##################################################################
//##################################################################
class FontTest extends mForm {
//##################################################################

mInput fontName, fontSize;
mButton doTest,testFrame;
mCheckBox fontBold;

public FontTest()
{
	recessed = true;
	mInputStack is = new mInputStack();
	addLast(is);
	fontName = is.addInput("Font Name:","Helvetica");
	fontSize = is.addInput("Font Size:","12");
	fontBold = is.addCheckBox("Bold:",null,false);
	doTest = is.addButton("Test Font");
	testFrame = is.addButton("Test Frames");
}

public void onControlEvent(ControlEvent ev)
{
	if (ev.type == ev.PRESSED){
 		if (ev.target == doTest){
			String fn = fontName.text;
			int fs = Convert.toInt(fontSize.text);
			int sty = Font.PLAIN;
			String typ = "Plain";
			if (fontBold.state) {
				sty = Font.BOLD;
				typ = "Bold";
			}
			MessageBox mb = new MessageBox("Testing Font",fn+"\nsize: "+fs+"\n"+typ,MBOK);
			mb.message.myFont = new Font(fn,sty,fs);
			mb.exec(null,null);
		}else if (ev.target == testFrame) {
			new FrameTest().show(getFrame(),null);
		}
	}
	super.onControlEvent(ev);
}
//##################################################################
}
//##################################################################
//##################################################################
class ListTest extends mForm{
//##################################################################

mButton add, remove;
mList list;
mCheckBox multi;
mInput selected;

public ListTest()
{
	recessed = true;
	addLast(multi = new mCheckBox("Multiple Selections"));
	list = new mList(5,20,false);
	list.addItems(mString.split(
	"Press Add to add the text in the input| to the end of the list.|Press Remove to remove selected items|from the list.|Note the scrollbars will adjust accordingly."));
	//"\"My butter, garcon, is writ large in!\"|A diner was heard to be chargin',|\"I had to write there\",|Exclaimed waiter Pierre,|\"I couldn't find room in the margerine.\"|E. Howe, H. Lenstra, D. Moulton")); 
	addLast(list.getScrollablePanel());
	ButtonBar bb = new ButtonBar();
	add = bb.add("Add"); remove = bb.add("Remove");
	addLast(bb);
	addLast(selected = new mInput());
	selected.columns = 40;
	mInputForm.attach(selected);
	selected.prompt = "Add Item:";
	selected.triggerOnSinglePress = true;
}

public void onControlEvent(ControlEvent ev)
{
	if (ev instanceof ListEvent && ev.target == list) {
		if (ev.type == ListEvent.SELECTED) {
			selected.text = ((MenuItem)((ListEvent)ev).selectedItem).label;
			selected.repaintDataNow();
		}
	}else if (ev.type == ev.PRESSED) {
		if(ev.target == multi) {
			list.multiSelect = multi.state;
			list.selectAll(false);
			list.updateItems();
		}else if (ev.target == add) {
			list.addItem(selected.text);
			list.updateItems();
		}else if (ev.target == remove) {
			Vector v = new Vector();
			for (int i = 0; i<list.items.size(); i++)
				if (list.isSelected(i)) v.addElement(list.getItemAt(i));
			for (int i = 0; i<v.size(); i++)
				list.items.removeElement(v.elementAt(i));
			list.selectAll(false);
			list.updateItems();
		}
	}
}
//##################################################################
}
//##################################################################

//##################################################################
class FrameTest extends mForm{
//##################################################################

static int frameNumber = 1;

int number;
mButton sibling, child;

public FrameTest()
{
	resizable = true;
	number = frameNumber++;
	title = "Frame: "+number;
	addLast(sibling = new mButton("Spawn Sibling"));
	addLast(child = new mButton("Spawn Child"));
}

public void onControlEvent(ControlEvent ev)
{
	if (ev.type == ev.PRESSED){
		if (ev.target == sibling)
			new FrameTest().show(getFrame().getFrame(),null);
		else if (ev.target == child)
			new FrameTest().show(getFrame(),null);
	}
	super.onControlEvent(ev);
}
//##################################################################
}
//##################################################################
//##################################################################
class SplitterTest extends mForm{
//##################################################################
CheckBoxGroup cg = new CheckBoxGroup();

SplitterTest()
{
	SplittablePanel all = new SplittablePanel(SplittablePanel.VERTICAL);
	SplittablePanel tools = new SplittablePanel(all.HORIZONTAL);
	tools._debug = true;
	mPanel p = tools.getNextPanel(tools.DONT_STRETCH_CONTENTS|tools.MAX_TO_PREFERRED_SIZE);
	p.addNext(new mChoice(mString.split("First|Second|Third"),0));
	mCheckBox cb;
	p.addNext(cb = new ButtonCheckBox("A")); cb.setGroup(cg);
	p.addNext(cb = new ButtonCheckBox("B")); cb.setGroup(cg);
	p.addNext(cb = new ButtonCheckBox("C")); cb.setGroup(cg);
	p = tools.getNextPanel(tools.CLOSED|tools.DONT_STRETCH_CONTENTS|tools.MAX_TO_PREFERRED_SIZE);
	ButtonBar bb = new ButtonBar();
	bb.add(mString.split("Four|Five|Six|Seven"));
	//p.fixedPreferredSize = new Rect(0,0,0,0);
	p.addLast(bb);
	p = tools.getNextPanel(tools.MAX_TO_PREFERRED_SIZE);
	p.addNext(new mInput("Hello"));
	mPanel top = all.getNextPanel();
	top.controlEntry.setMinimumSize(40,40);
	top.addLast(tools).setCell(HStretch);
	SplittablePanel buttons = new SplittablePanel(all.HORIZONTAL);
	p = buttons.getNextPanel(); p.controlEntry.setMinimumSize(20,20);
	p.addLast(new mButton("Left"));
	p = buttons.getNextPanel(); p.controlEntry.setMinimumSize(20,20);
	p.addLast(new mButton("Right"));
	top.addLast(buttons);
	mPanel bottom = all.getNextPanel();
	bottom.controlEntry.setMinimumSize(20,20);
	bottom.addLast(new mButton("Bottom"));
	addLast(all);
	addLast(new MessageArea("Drag the separators\nto resize the buttons."));
}

//##################################################################
}
//##################################################################

